"
 COPYRIGHT (c) 1997-1998 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice. This software may not
 be provided or otherwise made available to, or used by, any
 other person. No title to or ownership of the software is
 hereby transferred.
"



"{ Package: 'stx:libtool' }"

AbstractLauncherApplication subclass:#NewLauncher
	instanceVariableNames:'isMainLauncher helpIsOn'
	classVariableNames:'UserAddedMenuItems UserAddedToolBarItems'
	poolDictionaries:''
	category:'Interface-Smalltalk'
!

Object subclass:#AddedToolInfo
	instanceVariableNames:'item where positionSpec space before menuWithNewItem'
	classVariableNames:''
	poolDictionaries:''
	privateIn:NewLauncher
!

!NewLauncher class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997-1998 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice. This software may not
 be provided or otherwise made available to, or used by, any
 other person. No title to or ownership of the software is
 hereby transferred.
"


!

documentation
"
    The new launcher.
    This one provides all of the Launchers functionality, 
    but has been written using the new GUI painter tools.
    (i.e. its menu and toolbar is defined by specs, which can be
     easily modified).
    Functionality which can be shared with the old launcher
    has been moved to a common superclass.

    If you want to write your own (application-)launcher, we recommend
    creating a subclass, and redefining the appropriate menu & menuToolBar
    methods there.

    [start with:]
        NewLauncher open

    [see also:]
        Launcher

    [author:]
        Thomas Zwick, eXept Software AG
        Claus Gittinger, eXept Software AG
"

!

examples
"
    reopening a standard launcher (without any added tools)
                                                                        [exBegin]
     NewLauncher removeAllUserAddedTools.
     NewLauncher open.
                                                                        [exEnd]



    adding your own menu items (for user-applications)

    an additional item in the tools menu:
                                                                        [exBegin]
     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo';
                        value: [Transcript showCR:'foo invoked'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #foo;
                        activeHelpKey: #Foo)
        in:#menu
        position:(#before #workspace)
        space:true
                                                                        [exEnd]

    an additional item in the tools menu:
                                                                        [exBegin]
     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo';
                        value: [Transcript showCR:'foo invoked'];
                        isButton: false;
                        labelImage: nil;
                        activeHelpKey: #Foo)
        in:#menu
        position:(#after #guiPainter)
        space:true
                                                                        [exEnd]

    an additional item in one of the tools sub menus:
                                                                        [exBegin]
     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo';
                        value: [Transcript showCR:'foo invoked'];
                        isButton: false;
                        labelImage: nil;
                        activeHelpKey: #Foo)
        in:#menu
        position:'Workspace'
        before:true
        space:true
                                                                        [exEnd]
"

! !

!NewLauncher class methodsFor:'accessing'!

label

    ^'ST/X Launcher'


! !

!NewLauncher class methodsFor:'defaults'!

windowIcon
    ^ Icon stxIcon

    "Created: / 16.8.1998 / 13:11:58 / cg"
    "Modified: / 17.8.1998 / 10:07:09 / cg"
! !

!NewLauncher class methodsFor:'help specs'!

helpSpec
    "This resource specification was automatically generated
     by the UIHelpTool of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIHelpTool may not be able to read the specification."

    "
     UIHelpTool openOnClass:NewLauncher    
    "

    <resource: #help>

    ^super helpSpec addPairsFrom:#(

#aboutLicenseConditions
'Show the license conditions of ST/X.'

#chickenFun
'Watch your views'

#classes
'Class functions.'

#classesClassBrowser
'Open a dialog for defining and opening a Class Browser on a class.'

#classesClassBrowserOnChanges
'Open a Browser on changed classes'

#classesClassHierarchyBrowser
'Open a dialog for defining and opening a Class Hierarchy Browser on a class.'

#classesClassTreeBrowser
'Open a Class Tree on the classes of ST/X.'

#classesFullClassBrowser
'Open a dialog for defining and opening a Full Class Browser on a class.'

#classesImplementors
'Find all methods which implement a particular message'

#classesRemoveAllTracePoints
'Remove all trace- and break-points.'

#classesResourceMethods
'Open a dialog for searching resource methods.'

#classesSenders
'Find all methods which send a particular message.'

#classesShowTracePoints
'Open a list showing all trace- and break-points on methods.'

#classesSpecial
'Special class functions.'

#classesSpecialReferencesToUndeclared
'Open a list of methods refering to undeclared variables.'

#'newSystemBrowser'
'Open the new, improved System Browser.'

#classesSystemBrowser
'Open a System Browser.'

#classesSystemBrowserOnClass
'Open a System Browser on a previously modified class.'

#demos
'Demo programs.'

#demos3D
'3D GL graphic demos.'

#demos3DcubeSolid
'A rotating solid cube.'

#demos3DcubeWire
'A rotating wireframe cube.'

#demos3Ddoughnut
'A rotating wireframe doughnut.'

#demos3Dlogo
'The ST/X logo.'

#demos3Dplane
'A rotating plane.'

#demos3Dplanet
'Two spheres - one rotating around the other.'

#demos3Drubics
'A rubics cube - with interaction.'

#demos3Dsphere
'A rotating wireframe sphere.'

#demos3Dteapot
'A teopot.'

#demos3Dtetra
'A rotating tetrahedron.'

#demosAnimations
'Simple animation demos.'

#demosCalculator
'Opens a calculator with decimal to hex conversion.'

#demosCalendar
'Opens a GUI on the cal unix program.'

#demosClock
'Opens an analog clock application.'

#demosCommander
'Opens a demo for the Commander class.'

#demosDigitalClock
'Opens a digital clock application'

#demosFTP
'Opens a simple FTP interface demo.'

#demosFractalPatterns
'Opens a view displaying fractal patterns.'

#demosFractalPlants
'Opens a view displaying fractal plants (iterated function systems).'

#demosGUI
'GUI builder demos.'

#demosGUICalculator
'Calculator built using the GUI builder.'

#demosGUIWidgets
'GUI widgets usage.'

#demosGames
'Games.'

#demosGeometric
'Various demos displaying geometric designs.'

#demosGlobe
'Opens a rotating globe animation demo.'

#demosGoodies
'Goodies and Utilities.'

#demosGraphicEditors
'Graphic editing demos.'

#demosGraphicEditorsDrawTool
'Object drawing demo.'

#demosGraphicEditorsLogicTool
'Simulating Logic demo.'

#demosGraphicEditorsPaintTool
'Painting demo.'

#demosLSystems
'Opens a view displaying fractal patterns using Lindenmayer Systems.'

#demosMail
'Opens a simple mail viewer demo.'

#demosMandel
'Opens a view displaying the mandelbrot set.'

#demosMoreFractalPatterns
'Opens a view with more fractal patterns.'

#demosNews
'Opens a simple news reader demo.'

#demosPen
'Opens a demo for the Pen class.'

#demosRemoteLauncher
'Opens a launcher on a remote display.'

#demosTelnet
'Opens a Telnet terminal demo.'

#demosWalkingMan
'Opens a walking man animation demo.'

#fileApplicationBuilder
'Open an Application Builder for building stand alone ST/X-applications.'

#fileFileBrowser
'Open a FileBrowser to load and edit files.'

#fileLibraryBuilder
'Open a Library Builder for building binary class libraries.'

#fileModules
'Show class libraries and other modules.'

#fileSaveImage
'Save a snapshot image of ST/X into the current snapshot file.'

#fileSaveImageAs
'Save a snapshot image of ST/X into a file.'

#gamesPingPong
'Play classic PingPong against the computer.'

#gamesPingPong2
'Play classic PingPong against a friend.'

#gamesReversi
'The game of reversi (an embedded Java applet)'

#gamesTetris
'The tetris game - written in Smalltalk.'

#gamesTicTacToe
'Play TicTacToe against the computer.'

#gamesTicTacToe2
'Play TicTacToe against a friend.'

#helpActiveHelp
'Toggle display of active help texts in browsers.'

#helpClassDocumentation
'Show the smalltalk class documentation.'

#helpIndex
'Show the index of the online documentation.'

#helpPrintDocumentation
'Print various parts of the ST/X documentation.'

#helpSTXOnlineDocumentation
'Show the ST/X online documentation.'

#helpWhatsNew
'Show the latest news about the ST/X doc.'

#settingsCommunications
'Change communication settings.'

#settingsCompilation
'Change compiler settings.'

#settingsFonts
'Change of the font defaults.'

#settingsKeyboardMappings
'Show the keyboard mappings.'

#settingsLanguage
'Change the national language.'

#settingsLoadSettings
'Restore the settings from a file.'

#settingsMessages
'Change the settings for info- / error-messagess.'

#settingsMisc
'Misc other settings.'

#settingsObjectMemory
'Change the object memory settings.'

#settingsPrinter
'Change the printer setup.'

#settingsSaveSettings
'Save the current settings to a file.'

#settingsScreen
'Change the display screen settings.'

#settingsSourceAndDebugger
'Change the settings of the source code management.'

#settingsTools
'Change tool settings.'

#settingsViewStyle
'Change the current view style.'

#system
'System tools.'

#systemEventTrace
'Select a view to toggle the event trace for it.'

#systemEventView
'Open a view and trace its window events on the console.'

#systemGarbageCollect
'Reclaim unused memory.'

#systemGarbageCollectAndCompress
'Reclaim unused memory and minimize the amount of used memory.'

#systemInterruptLatency
'Open an Interrupt Latency Monitor displaying methods which block interrupts for longer than a given time goal.'

#systemMemory
'Display object memory statistics.'

#systemMemoryUsage
'Display object memory usage by class.'

#systemProcesses
'Open a Process Monitor displaying ST/X processes.'

#systemSemaphores
'Open a Semaphore Monitor displaying ST/X semaphores.'

#tools
'Tools.'

#toolsChangesBrowser
'Open a Changes Browser.'

#toolsGUIPainter
'Open a GUI Painter for graphical user interface construction.'

#toolsImageEditor
'Open a Bitmap Image Editor.'

#toolsMenuEditor
'Open a Menu Editor for building menu bars, popup menus, and tool bars.'

#toolsMisc
'Misc Tools.'

#toolsMiscNewChangesBrowser
'Open a ChangesBrowser (new GUI).'

#toolsMiscNewLauncher
'(Re-)open a Launcher (new GUI).'

#toolsMiscOldChangesBrowser
'Open a ChangesBrowser (old GUI).'

#toolsMiscOldLauncher
'Open an OldLauncher.'

#toolsMiscProjects
'Project functions.'

#toolsMiscProjectsNewProject
'Create a new project.'

#toolsMiscProjectsSelectProject
'Select an existing project and reopen its windows.'

#toolsNewChangesBrowser
'Open the new changes browser.'

#toolsOldChangesBrowser
'Open the old changes browser.'

#toolsProjects
''

#toolsTerminal
'Open a terminal view (aka xterm)'

#toolsWorkspace
'Open a Workspace for evaluating smalltalk expressions.'

#windows
'Window functions.'

#windowsDeiconifyAll
'Restore all minimized ST/X windows.'

#windowsMigrateAllWindows
'Migrate all ST/X windows to some other display.'

#windowsFindAndMigrate
'Select an ST/X window by name and move it to another display.'

#windowsFindAndMigrateBack
'Select an ST/X window by name and move it (back) to this screen.'

#windowsFindAndDestroy
'Select an ST/X window by name and destroy it.'

#windowsFindAndRaise
'Select an ST/X window by name and raise it.'

#windowsGrapScreen
'Grab the whole screen and save it to a bitmap-file.'

#windowsGrapScreenArea
'Grab an area of the screen and save it to a bitmap-file.'

#windowsGrapWidget
'Grab a single widget and save it to a bitmap-file.'

#windowsGrapWindow
'Grab a window and save it to a bitmap-file.'

#windowsIconifyAll
'Minimize all ST/X windows to icons.'

#windowsRedrawAll
'Redraw all ST/X windows.'

#windowsSelectAndDestroy
'Select a window and destroy it.'

#windowsSelectAndInspect
'Select an ST/X window and open an Inspector on it.'

#windowsSelectAndMigrate
'Select an ST/X window and move it to another display.'

#windowsViewTree
'Select an ST/X window and display its widget hierarchy.'

#windowsViewTreeAllViews
'Display the widget hierarchies of all ST/X windows (on this display).'

#windowsViewTreeAllScreens
'Display the widget hierarchies of all ST/X windows (on all displays).'

)
! !

!NewLauncher class methodsFor:'image specs'!

helpIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self helpIcon inspect
     ImageEditor openOnClass:self andSelector:#helpIcon
    "

    <resource: #image>

    ^Icon
        constantNamed:#'NewLauncher helpIcon'
        ifAbsentPut:[(Depth2Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(2 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@E@@@@@@J*(D@@@@@***)P@@@@@@J*E@@@@K.,J(T@@@;.>8*E@@@K.:;"(T@@J;..;JE@@K; N;"!!P@C+ B;,(T@@/ @K.JE@@N,@C.2E@@B>@@.3!!
P@@@@@.8!!T@@@@@+.1P@@@@@/.1P@@@@@N.0P@@@@@N>2D@@@@@B:8!!@@@@@@;8(P@@@@@K+H@@@@@@@@BA@@@@@@J*HP@@@@@@@JD@@@@@C/"!!@@@@@@.,(
@@@@@@N>H@@@@@@@@@@@@@@a') ; colorMapFromArray:#[0 0 0 63 79 96 255 255 0 255 255 255]; mask:((ImageMask new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@?8@@@??@@@_?8@@O??@@G??8@C??>@@???0@_??<@O???@C>O?0@?C?<@O0?>@C<O? @?C?8@@C?8@@A?<@@@_>@@@O? @@C?8@@@?>@@@O>@@@C?8@@@_
>@@@O? @@C?8@@@?<@@@O>@@@C?@@@@a') ; yourself); yourself]
!

helpIcon2
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self helpIcon2 inspect
     ImageEditor openOnClass:self andSelector:#helpIcon2
    "

    <resource: #image>

    ^Icon
        constantNamed:#'NewLauncher helpIcon2'
        ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@@@@@@@@@@@@@@@@@@@H@@@@@@@@@@@@@@@@@@3H@@@@@@@@@@@@@@@@CL2@@@@@@@@@@@@@@@@L3L @@@@@@@@@@@@@@@3L3@@@@@@@@@@@@@BLCL3
L0@@@@L3@@@@@CL0L3L3@@H3L3L0@@A@L3@3L3LBH#L3L3A@@D@3LCL3L0H"L3L3LD@@PCL0L3L3@"D3L1L0P@A@L3@3L3LBH!!L1L3A@@D@3LCL3L0H"HQL3
LD@@PCL0L3L3@"H#D3L0P@A@L3@3L3LBH"D1L3A@A@L3LBL3L0H"D3LSLD@D@3L0H#L3@"D#L3D0P@PCL3LBH#LBHRL3L3A@A@L3L3@"H0H"H3L3LD@D@3L3
L H"@"H#L3L0P@PCL3L"@"HBH"L3L3A@A@H"H"H H H"H#L2HD@D@@H"H"HB@"H"H"H@P@ADP@H"H HBH"H @DQ@@@@DP@@"H@H"H@Q@@@@@@@@@Q@@B@ @D
P@@@@@@@@@@@AD@@Q@@@@@@@@@@@@@@@@@@@@@@@@@@b') ; colorMapFromArray:#[0 0 0 0 128 92 192 192 192 253 253 253 191 191 0]; mask:((ImageMask new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@X@@@@G @@@A<@@@@_ @@@G<@@@G?@\@C?9? C????A????0_???<G????A????0_???<G????A????0????<O????C????0????<O????C????0????<O??
??C????0O???8@_?? @@?? @@A?@@@@a') ; yourself); yourself]
!

helpIcon3
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self helpIcon3 inspect
     ImageEditor openOnClass:self andSelector:#helpIcon3
    "

    <resource: #image>

    ^Icon
        constantNamed:#'NewLauncher helpIcon3'
        ifAbsentPut:[(Depth2Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(2 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@@@@@@@0@@@@@@@@E0@@@@@@@AW@@@@@@@@U\@@@@@@@EU@@@@@@CQUT@@U@@ATUU@5UP@HUEUS=UWHBEQUT?UUR@!!TUUO5UT HUEUS=UUHBEQUT?5U
R@!!TUUO=UT HUEUS?UUHH5QUT?5URBETMUO=UT !!UTMS?UUHHUU<4?5URBEU_3O=UT  @W?C?U@HH?0O<?0O2B@?<CLC?0 J ??@?<B(@B O??0(@@@@(C<B
 @@@@@J@(@@@@@@@@@@@@@@a') ; colorMapFromArray:#[0 0 0 253 253 253 191 191 0 192 192 192]; mask:((ImageMask new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@X@@@@G @@@A<@@@@_ @@@G<@@@G?@\@C?9? C????A????0_???<G????A????0_???<G????A????0????<O????C????0????<O????C????0????<O??
??C????0O???8@_?? @@?? @@A?@@@@a') ; yourself); yourself]
! !

!NewLauncher class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:NewLauncher andSelector:#windowSpec
     NewLauncher new openInterface:#windowSpec
     NewLauncher open
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Launcher'
              #layout: #(#LayoutFrame 407 0 353 0 697 0 554 0)
              #label: 'Launcher'
              #min: #(#Point 374 44)
              #max: #(#Point 1152 900)
              #bounds: #(#Rectangle 407 353 698 555)
              #menu: #menu
              #usePreferredExtent: false
              #icon: #windowIcon
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#MenuPanelSpec
                    #name: 'menuToolbarView'
                    #layout: #(#LayoutFrame 0 0.0 0 0 0 1.0 38 0)
                    #menu: #menuToolbar
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                )
                 #(#WorkspaceSpec
                    #name: 'transcriptView'
                    #layout: #(#LayoutFrame 0 0.0 40 0.0 0 1.0 -26 1.0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                    #miniScrollerHorizontal: true
                )
                 #(#UISubSpecification
                    #name: 'infoBarSubSpec'
                    #layout: #(#LayoutFrame 0 0.0 -24 1 0 1.0 0 1.0)
                    #majorKey: #ToolApplicationModel
                    #minorKey: #windowSpecForInfoBarWithClock
                )
              )
          )
      )

    "Modified: / 10.9.1998 / 22:00:11 / cg"
    "Modified: / 29.1.1999 / 14:55:37 / stefan"
! !

!NewLauncher class methodsFor:'menu configuration'!

addMenuItem:newItem in:where position:positionSpecOrNilArg space:space
    |positionSpecOrNil itemNameOrNil before launcherApp|

    (Transcript notNil 
    and:[ Transcript isStream not
    and:[ (launcherApp := Transcript application) notNil
    and:[ launcherApp isKindOf:self]]]) ifTrue:[
        "/ add to instance
        launcherApp addMenuItem:newItem in:where position:positionSpecOrNilArg space:space.
        ^ self
    ].

    positionSpecOrNil := positionSpecOrNilArg.
    positionSpecOrNil isArray ifTrue:[
        positionSpecOrNil size > 1 ifTrue:[
            itemNameOrNil := positionSpecOrNil at:2.
        ].
        positionSpecOrNil := positionSpecOrNil at:1.
    ].
    before := (positionSpecOrNil == #first) or:[positionSpecOrNil == #before].

    (where isNil or: [where = 'toolbar']) ifTrue:[
        UserAddedToolBarItems isNil ifTrue: [UserAddedToolBarItems := Dictionary new].
        UserAddedToolBarItems at:newItem put:(AddedToolInfo new
                                            item:newItem;
                                            where:where;
                                            positionSpec:positionSpecOrNilArg;
                                            space:space;
                                            before:before;
                                            menuWithNewItem:nil;
                                            yourself)
    ].
    (where isNil or:[where startsWith:'menu']) ifTrue:[
        UserAddedMenuItems isNil ifTrue: [UserAddedMenuItems := Dictionary new].
        UserAddedMenuItems at:newItem put:(AddedToolInfo new
                                            item:newItem;
                                            where:where;
                                            positionSpec:positionSpecOrNilArg;
                                            space:space;
                                            before:before;
                                            menuWithNewItem:nil;
                                            yourself)
    ]
!

removeAllUserAddedTools
    UserAddedTools := nil
!

removeUserTool:toolNameOrMenuItem
    "removes a menu item labeled toolName
     This can be invoked by a classes #deinitialize method, 
     to remove its item from the toolbar or menu.
    "

    self removeUserTool:toolNameOrMenuItem from:UserAddedToolBarItems.
    self removeUserTool:toolNameOrMenuItem from:UserAddedMenuItems.

    "
     Transcript topView application
        removeUserTool:'Bar' 
    "
    "
     Transcript topView application
        removeUserTool:'Foo' 
    "


!

removeUserTool:toolNameOrMenuItem from:addedToolsCollection
    "removes a menu item labeled toolName
     This can be invoked by a classes #deinitialize method, 
     to remove its item from the toolbar or menu.
    "

    |info space menuIndex removeInMenuBlock whichMenu before menuItemToRemove|

    addedToolsCollection size == 0 ifTrue: [^nil].

    [true] whileTrue:[
        (toolNameOrMenuItem isString or:[toolNameOrMenuItem isSymbol]) ifTrue:[
            info := addedToolsCollection detect:[:eachInfo | |eachItem|
                                            eachItem := eachInfo item.
                                            (eachItem nameKey notNil and:[ toolNameOrMenuItem = eachItem nameKey])
                                            or:[ (eachItem activeHelpKey notNil and:[ toolNameOrMenuItem = eachItem activeHelpKey])
                                            or:[ (eachItem label notNil and:[ toolNameOrMenuItem = eachItem label])]]
                                          ]
                                   ifNone:nil.
        ] ifFalse:[
            info := addedToolsCollection detect:[:eachInfo | |eachItem| eachItem := eachInfo item. (eachItem == toolNameOrMenuItem)] ifNone:nil.
        ].
        info isNil ifTrue:[^ self].

        space     := info space.
        whichMenu := info menuWithNewItem.
        menuItemToRemove := info item.
        before := info before.

        whichMenu notNil ifTrue:[
            menuIndex := whichMenu findFirst:[:item | 
                                                    (item nameKey notNil and:[item nameKey == menuItemToRemove nameKey])
                                                    or:[ (item activeHelpKey notNil and:[item activeHelpKey == menuItemToRemove activeHelpKey])
                                                    or:[ (item label notNil and:[item label = menuItemToRemove label]) ]]
                                             ].
            menuIndex ~~ 0 ifTrue:[              
                whichMenu remove: menuIndex.
                space ifTrue: [
                    whichMenu remove:(menuIndex - (before ifTrue:0 ifFalse:1))
                ].
            ].
        ].
        addedToolsCollection removeKey:menuItemToRemove. 
        ^ self
    ].


    "
     Transcript topView application
        removeUserTool:'Bar' 
    "
    "
     Transcript topView application
        removeUserTool:'Foo' 
    "



! !

!NewLauncher class methodsFor:'menu specs'!

aboutMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#aboutMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher aboutMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'About Smalltalk/X...'
            #translateLabel: true
            #value: #openAbout
            #activeHelpKey: #aboutSTX
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Licence Conditions'
            #translateLabel: true
            #value: #openLicenseConditions
            #activeHelpKey: #aboutLicenseConditions
          )
         )
        nil
        nil
      )
!

classesMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#classesMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher classesMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'System Browser'
            #translateLabel: true
            #nameKey: #systemBrowser
            #value: #openApplication:
            #activeHelpKey: #classesSystemBrowser
            #argument: 'SystemBrowser'
            #labelImage: #(#ResourceRetriever nil #startSystemBrowserIcon 'System Browser')
          )
         #(#MenuItem
            #label: 'System Browser on Class'
            #translateLabel: true
            #nameKey: #systemBrowserOnClass
            #activeHelpKey: #classesSystemBrowserOnClass
            #labelImage: #(#ResourceRetriever nil #startSystemBrowserOnHistoryClassIcon 'System Browser on Class')
            #submenuChannel: #menuClassHistory
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Changed Classes'
            #translateLabel: true
            #nameKey: #classBrowserOnChanges
            #value: #startClassBrowserOnChanges
            #activeHelpKey: #classesClassBrowserOnChanges
          )
         #(#MenuItem
            #label: 'Class Browser on...'
            #translateLabel: true
            #nameKey: #classBrowserOn
            #value: #startClassBrowser
            #activeHelpKey: #classesClassBrowser
          )
         #(#MenuItem
            #label: 'Full Class Browser on...'
            #translateLabel: true
            #value: #startFullClassBrowser
            #activeHelpKey: #classesFullClassBrowser
          )
         #(#MenuItem
            #label: 'Class Hierarchy Browser on...'
            #translateLabel: true
            #value: #startClassHierarchyBrowser
            #activeHelpKey: #classesClassHierarchyBrowser
          )
         #(#MenuItem
            #label: 'Class Tree'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #classesClassTreeBrowser
            #argument: 'ClassTreeGraphView'
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Implementors of...'
            #translateLabel: true
            #value: #browseImplementors
            #activeHelpKey: #classesImplementors
          )
         #(#MenuItem
            #label: 'Senders of...'
            #translateLabel: true
            #value: #browseSenders
            #activeHelpKey: #classesSenders
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Special'
            #translateLabel: true
            #nameKey: #special
            #value: #special
            #activeHelpKey: #classesSpecial
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'References To Undeclared'
                  #translateLabel: true
                  #value: #browseUndeclared
                  #activeHelpKey: #classesSpecialReferencesToUndeclared
                )
               #(#MenuItem
                  #label: 'Find Resource Methods...'
                  #translateLabel: true
                  #value: #browseResources
                  #activeHelpKey: #classesResourceMethods
                )
               #(#MenuItem
                  #label: 'Show All Break && Trace Points'
                  #translateLabel: true
                  #value: #browseAllBreakAndTracePoints
                  #activeHelpKey: #classesShowTracePoints
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Remove All Break && Trace Points'
                  #translateLabel: true
                  #value: #removeAllBreakAndTracePoints
                  #activeHelpKey: #classesRemoveAllTracePoints
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
!

demosMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#demosMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher demosMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Goodies'
            #translateLabel: true
            #activeHelpKey: #demosGoodies
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Clock'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosClock
                  #argument: 'Clock'
                )
               #(#MenuItem
                  #label: 'Digital Clock'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosDigitalClock
                  #argument: 'DigitalClockView'
                )
               #(#MenuItem
                  #label: 'Calendar'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosCalendar
                  #argument: 'Calendar'
                )
               #(#MenuItem
                  #label: 'Calculator'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosCalculator
                  #argument: 'CalculatorView'
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Mail Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosMail
                  #argument: 'MailView'
                )
               #(#MenuItem
                  #label: 'News Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosNews
                  #argument: 'NewsView'
                )
               #(#MenuItem
                  #label: 'FTP Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosFTP
                  #argument: 'FTPTool'
                )
               #(#MenuItem
                  #label: 'Telnet Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosTelnet
                  #argument: 'TelnetTool'
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Remote Launcher...'
                  #translateLabel: true
                  #value: #startRemoteLauncher
                  #activeHelpKey: #demosRemoteLauncher
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Games'
            #translateLabel: true
            #activeHelpKey: #demosGames
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Tetris'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #gamesTetris
                  #argument: 'Games::Tetris'
                )
               #(#MenuItem
                  #label: 'Tic Tac Toe'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #gamesTicTacToe
                  #argument: 'Games::TicTacToeGame'
                )
               #(#MenuItem
                  #label: 'Tic Tac Toe (2 players)'
                  #translateLabel: true
                  #value: #startTicTacToe2
                  #activeHelpKey: #gamesTicTacToe2
                )
               #(#MenuItem
                  #label: 'PingPong'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #gamesPingPong
                  #argument: 'Games::PingPongGame'
                )
               #(#MenuItem
                  #label: 'PingPong - (2 players)'
                  #translateLabel: true
                  #value: #startPingPong2
                  #activeHelpKey: #gamesPingPong2
                )
               #(#MenuItem
                  #label: 'Reversi (Java)'
                  #translateLabel: true
                  #value: #startReversi
                  #activeHelpKey: #gamesReversi
                )
               #(#MenuItem
                  #label: 'Towers of Hanoi (Prolog)'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'Prolog::TowersOfHanoiApplication'
                )
               #(#MenuItem
                  #label: 'MasterMind (Prolog)'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'Prolog::MasterMind'
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Geometric Designs'
            #translateLabel: true
            #activeHelpKey: #demosGeometric
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Pen Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosPen
                  #argument: 'PenDemo'
                )
               #(#MenuItem
                  #label: 'Commander Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosCommander
                  #argument: 'CommanderDemo'
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Mandel'
                  #translateLabel: true
                  #value: #openMandelbrotDemo
                  #activeHelpKey: #demosMandel
                )
               #(#MenuItem
                  #label: 'Fractal Plants Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosFractalPlants
                  #argument: 'FractalPlantsDemo'
                )
               #(#MenuItem
                  #label: 'Fractal Patterns Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosFractalPatterns
                  #argument: 'FractalPatternsDemo'
                )
               #(#MenuItem
                  #label: 'Lindenmayer Patterns Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosLSystems
                  #argument: 'LSystemsDemo'
                )
               #(#MenuItem
                  #label: 'More Fractal Patterns Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosMoreFractalPatterns
                  #argument: 'ArmchairUniverseDemo'
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Simple Animations'
            #translateLabel: true
            #activeHelpKey: #demosAnimations
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Walking Man'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosWalkingMan
                  #argument: 'Animation'
                )
               #(#MenuItem
                  #label: 'Globe Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGlobe
                  #argument: 'GlobeDemo'
                )
               #(#MenuItem
                  #label: 'Chicken Fun'
                  #translateLabel: true
                  #value: #startStopDemo:
                  #activeHelpKey: #chickenFun
                  #argument: 'ChickenFun'
                  #indication: #chickenFunIsRunning
                )
               #(#MenuItem
                  #label: 'Chicks Eyes'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #chickenFun
                  #argument: 'ChickenEyes'
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: '3D GL Graphics'
            #translateLabel: true
            #isVisible: #displaySupportsGLDrawing
            #activeHelpKey: #demos3D
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Plane'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dplane
                  #argument: 'GLPlaneDemoView2'
                )
               #(#MenuItem
                  #label: 'Tetra'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dtetra
                  #argument: 'GLTetraDemoView'
                )
               #(#MenuItem
                  #label: 'Cube (wireframe)'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3DcubeWire
                  #argument: 'GLWireCubeDemoView'
                )
               #(#MenuItem
                  #label: 'Cube (solid)'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3DcubeSolid
                  #argument: 'GLCubeDemoView'
                )
               #(#MenuItem
                  #label: 'Sphere (wireframe)'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dsphere
                  #argument: 'GLWireSphereDemoView'
                )
               #(#MenuItem
                  #label: 'Doughnut (wireframe)'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Ddoughnut
                  #argument: 'GLDoughnutDemoView'
                )
               #(#MenuItem
                  #label: 'Planet'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dplanet
                  #argument: 'GLPlanetDemoView'
                )
               #(#MenuItem
                  #label: 'Teapot'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dteapot
                  #argument: 'GLTeapotDemo'
                )
               #(#MenuItem
                  #label: 'Logo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demos3Dlogo
                  #argument: 'Logo3DView1'
                )
               #(#MenuItem
                  #label: 'Rubics Cube'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosCommander
                  #argument: 'RubicsCubeView'
                )
               #(#MenuItem
                  #label: 'X/Y Graph'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'GLXYGraph'
                )
               #(#MenuItem
                  #label: 'X/Y Graph Widget'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'CodingExamples_GUI::GLXYGraph3DDemo'
                )
               #(#MenuItem
                  #label: 'X/Y Graph Animated'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'CodingExamples_GUI::AnimatedGLXYGraph3DDemo'
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Cube (light)'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'GLCubeDemoView2'
                )
               #(#MenuItem
                  #label: 'Cube (light and texture)'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'GLBrickCubeDemoView'
                )
               #(#MenuItem
                  #label: 'Sphere (light)'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'GLSphereDemoView2'
                )
               #(#MenuItem
                  #label: 'Colored Octahedron'
                  #translateLabel: true
                  #value: #openDemo:
                  #argument: 'GLOctaHedronDemoView'
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Graphic Editors'
            #translateLabel: true
            #activeHelpKey: #demosGraphicEditors
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Draw Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGraphicEditorsDrawTool
                  #argument: 'DrawTool'
                )
               #(#MenuItem
                  #label: 'Logic Tool'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGraphicEditorsLogicTool
                  #argument: 'LogicTool'
                )
               #(#MenuItem
                  #label: 'Paint Demo'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGraphicEditorsPaintTool
                  #argument: 'ColorDrawDemo3'
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'GUI'
            #translateLabel: true
            #activeHelpKey: #demosGUI
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Widget Gallery'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGUIWidgets
                  #argument: 'CodingExamples_GUI::GUIDemo'
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Calculator'
                  #translateLabel: true
                  #value: #openDemo:
                  #activeHelpKey: #demosGUICalculator
                  #argument: 'CodingExamples_GUI::GUIDemoCalculator'
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
!

fileMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#fileMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher fileMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'File Browser'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #fileFileBrowser
            #argument: 'FileBrowser'
            #labelImage: #(#ResourceRetriever nil #startFileBrowserIcon 'File Browser')
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Modules...'
            #translateLabel: true
            #value: #objectModuleDialog
            #activeHelpKey: #fileModules
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Packages...'
            #translateLabel: true
            #isVisible: #packageDialogVisible
            #value: #packageDialog
            #activeHelpKey: #filePackages
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Library Builder'
            #translateLabel: true
            #isVisible: #libraryBuilderAvailable
            #value: #openApplication:
            #activeHelpKey: #fileLibraryBuilder
            #argument: 'LibraryBuilder'
          )
         #(#MenuItem
            #label: 'Application Builder'
            #translateLabel: true
            #isVisible: #libraryBuilderAvailable
            #value: #openApplication:
            #activeHelpKey: #fileApplicationBuilder
            #argument: 'ApplicationBuilder'
          )
         #(#MenuItem
            #label: '-'
            #isVisible: #libraryBuilderAvailable
          )
         #(#MenuItem
            #label: 'Save Image'
            #translateLabel: true
            #value: #saveImage
            #activeHelpKey: #fileSaveImage
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Save Image As...'
            #translateLabel: true
            #value: #saveImageAs
            #activeHelpKey: #fileSaveImageAs
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Exit...'
            #translateLabel: true
            #isVisible: #isMainLauncherHolder
            #value: #exit
            #activeHelpKey: #fileExit
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Close...'
            #translateLabel: true
            #isVisible: #isNotMainLauncherHolder
            #value: #closeRequest
            #activeHelpKey: #fileClose
          )
         )
        nil
        nil
      )
!

helpMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#helpMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher helpMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'What''s New in the Documentation'
            #translateLabel: true
            #value: #startWhatsNewDocumentation
            #activeHelpKey: #helpWhatsNew
          )
         #(#MenuItem
            #label: 'What''s New in ST/X'
            #translateLabel: true
            #value: #startWhatsNewSTX
            #activeHelpKey: #helpReleaseNotes
          )
         #(#MenuItem
            #label: 'Index'
            #translateLabel: true
            #value: #startDocumentationIndex
            #activeHelpKey: #helpIndex
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'ST/X Online Documentation'
            #translateLabel: true
            #value: #startDocumentationTool
            #activeHelpKey: #helpSTXOnlineDocumentation
            #labelImage: #(#ResourceRetriever nil #helpIcon2 'ST/X Online Documentation')
          )
         #(#MenuItem
            #label: 'Class Documentation'
            #translateLabel: true
            #value: #startClassDocumentation
            #activeHelpKey: #helpClassDocumentation
            #labelImage: #(#ResourceRetriever nil #helpIcon 'Class Documentation')
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Print Documentation...'
            #translateLabel: true
            #value: #showBookPrintDocument
            #activeHelpKey: #helpPrintDocumentation
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Active Help'
            #translateLabel: true
            #isVisible: #showActiveHelpMenuItem
            #value: #toggleActiveHelp:
            #activeHelpKey: #helpActiveHelp
            #indication: #activeHelp
          )
         #(#MenuItem
            #label: 'Show Help Texts'
            #translateLabel: true
            #activeHelpKey: #helpShowHelp
            #indication: #showingHelp:
          )
         )
        nil
        nil
      )
!

menu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#menu
     (Menu new fromLiteralArrayEncoding:(NewLauncher menu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'About'
            #translateLabel: true
            #nameKey: #about
            #activeHelpKey: #settings
            #labelImage: #(#ResourceRetriever nil #menuIcon)
            #submenuChannel: #aboutMenu
          )
         #(#MenuItem
            #label: '&File'
            #translateLabel: true
            #nameKey: #file
            #activeHelpKey: #settings
            #submenuChannel: #fileMenu
          )
         #(#MenuItem
            #label: 'Classes'
            #translateLabel: true
            #nameKey: #classes
            #activeHelpKey: #settings
            #submenuChannel: #classesMenu
          )
         #(#MenuItem
            #label: 'Tools'
            #translateLabel: true
            #nameKey: #tools
            #activeHelpKey: #settings
            #submenuChannel: #toolsMenu
          )
         #(#MenuItem
            #label: 'System'
            #translateLabel: true
            #nameKey: #system
            #activeHelpKey: #settings
            #submenuChannel: #systemMenu
          )
         #(#MenuItem
            #label: 'Settings'
            #translateLabel: true
            #nameKey: #settings
            #activeHelpKey: #settings
            #submenuChannel: #settingsMenu
          )
         #(#MenuItem
            #label: 'Windows'
            #translateLabel: true
            #nameKey: #windows
            #activeHelpKey: #settings
            #submenuChannel: #windowsMenu
          )
         #(#MenuItem
            #label: 'Demos'
            #translateLabel: true
            #nameKey: #demos
            #activeHelpKey: #settings
            #submenuChannel: #demosMenu
          )
         #(#MenuItem
            #label: '&Help'
            #translateLabel: true
            #nameKey: #help
            #startGroup: #right
            #activeHelpKey: #settings
            #submenuChannel: #helpMenu
          )
         )
        nil
        nil
      )
!

menuToolbar
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#menuToolbar
     (Menu new fromLiteralArrayEncoding:(NewLauncher menuToolbar)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'open workspace'
            #isButton: true
            #nameKey: #workspace
            #value: #openApplication:
            #activeHelpKey: #toolsWorkspace
            #argument: 'Workspace'
            #labelImage: #(#ResourceRetriever nil #startWorkspaceIcon)
          )
         #(#MenuItem
            #label: 'open file browser'
            #isButton: true
            #nameKey: #fileBrowser
            #value: #openApplication:
            #activeHelpKey: #fileFileBrowser
            #argument: 'FileBrowser'
            #labelImage: #(#ResourceRetriever nil #startFileBrowserIcon)
          )
         #(#MenuItem
            #label: 'save image'
            #isButton: true
            #nameKey: #saveImage
            #value: #saveImageAs
            #activeHelpKey: #fileSaveImageAs
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
            #labelImage: #(#ResourceRetriever nil #saveImageIcon)
          )
         #(#MenuItem
            #label: ''
          )
         #(#MenuItem
            #label: 'open system browser'
            #isButton: true
            #nameKey: #systemBrowser
            #value: #openApplication:
            #activeHelpKey: #classesSystemBrowser
            #argument: 'SystemBrowser'
            #labelImage: #(#ResourceRetriever nil #startSystemBrowserIcon)
          )
         #(#MenuItem
            #label: 'System Browser On Class'
            #isButton: true
            #activeHelpKey: #classesSystemBrowserOnClass
            #labelImage: #(#ResourceRetriever nil #startSystemBrowserOnHistoryClassIcon)
            #submenuChannel: #menuClassHistory
          )
         #(#MenuItem
            #label: 'open changes browser'
            #isButton: true
            #nameKey: #changesBrowser
            #value: #startChangesBrowser
            #activeHelpKey: #toolsChangesBrowser
            #labelImage: #(#ResourceRetriever nil #startChangesBrowserIcon)
          )
         #(#MenuItem
            #label: ''
          )
         #(#MenuItem
            #label: 'open GUI Builder'
            #isButton: true
            #nameKey: #guiBuilder
            #value: #openApplication:
            #activeHelpKey: #toolsGUIPainter
            #argument: 'UIPainter'
            #labelImage: #(#ResourceRetriever nil #startUIPainterIcon)
          )
         #(#MenuItem
            #label: 'open menu editor'
            #isButton: true
            #nameKey: #menuEditor
            #value: #openApplication:
            #activeHelpKey: #toolsMenuEditor
            #argument: 'MenuEditor'
            #labelImage: #(#ResourceRetriever nil #startMenuEditorIcon)
          )
         #(#MenuItem
            #label: 'open image editor'
            #isButton: true
            #nameKey: #imageEditor
            #value: #openApplication:
            #activeHelpKey: #toolsImageEditor
            #argument: 'ImageEditor'
            #labelImage: #(#ResourceRetriever nil #startImageEditorIcon)
          )
         #(#MenuItem
            #label: ''
          )
         #(#MenuItem
            #label: 'garbage collect and compress'
            #isButton: true
            #nameKey: #garbageCollect
            #value: #compressingGarbageCollect
            #activeHelpKey: #systemGarbageCollectAndCompress
            #labelImage: #(#ResourceRetriever nil #garbageCollectIcon)
          )
         #(#MenuItem
            #label: 'help'
            #translateLabel: true
            #isButton: true
            #nameKey: #help
            #startGroup: #right
            #value: #startDocumentationTool
            #activeHelpKey: #helpSTXOnlineDocumentation
            #labelImage: #(#ResourceRetriever nil #helpIcon2)
          )
         )
        nil
        nil
      )
!

settingsMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#settingsMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher settingsMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Language...'
            #translateLabel: true
            #value: #languageSetting
            #activeHelpKey: #settingsLanguage
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Keyboard Mappings...'
            #translateLabel: true
            #value: #keyboardSetting
            #activeHelpKey: #settingsKeyboardMappings
          )
         #(#MenuItem
            #label: 'View Style...'
            #translateLabel: true
            #value: #viewStyleSetting
            #activeHelpKey: #settingsViewStyle
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Fonts...'
            #translateLabel: true
            #value: #fontSettings
            #activeHelpKey: #settingsFonts
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Messages...'
            #translateLabel: true
            #value: #messageSettings
            #activeHelpKey: #settingsMessages
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Compilation...'
            #translateLabel: true
            #value: #compilerSettings
            #activeHelpKey: #settingsCompilation
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Object Memory...'
            #translateLabel: true
            #value: #memorySettings
            #activeHelpKey: #settingsObjectMemory
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Source And Debugger...'
            #translateLabel: true
            #value: #sourceAndDebuggerSettings
            #activeHelpKey: #settingsSourceAndDebugger
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Tools...'
            #translateLabel: true
            #value: #toolSettings
            #activeHelpKey: #settingsTools
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Java...'
            #translateLabel: true
            #isVisible: #javaSupportPresent
            #value: #javaSettings
            #activeHelpKey: #settingsJava
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Printer...'
            #translateLabel: true
            #value: #printerSettings
            #activeHelpKey: #settingsPrinter
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Screen...'
            #translateLabel: true
            #value: #displaySettings
            #activeHelpKey: #settingsScreen
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Editing...'
            #translateLabel: true
            #value: #editSettings
            #activeHelpKey: #settingsMisc
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Misc...'
            #translateLabel: true
            #value: #miscSettings
            #activeHelpKey: #settingsMisc
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Communications...'
            #translateLabel: true
            #activeHelpKey: #settingsCommunications
            #value: #communicationsSettings
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Save Settings...'
            #translateLabel: true
            #value: #saveSettings
            #activeHelpKey: #settingsSaveSettings
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Load Settings...'
            #translateLabel: true
            #value: #loadSettings
            #activeHelpKey: #settingsLoadSettings
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         )
        nil
        nil
      )
!

systemMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#systemMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher systemMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Memory'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #systemMemory
            #argument: 'MemoryMonitor'
          )
         #(#MenuItem
            #label: 'Memory Usage'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #systemMemoryUsage
            #argument: 'MemoryUsageView'
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Processes'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #systemProcesses
            #argument: 'ProcessMonitor'
          )
         #(#MenuItem
            #label: 'Semaphores'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #systemSemaphores
            #argument: 'SemaphoreMonitor'
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Interrupt Latency'
            #translateLabel: true
            #value: #startLatencyMonitor
            #activeHelpKey: #systemInterruptLatency
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Event View'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #systemEventView
            #argument: 'EventMonitor'
          )
         #(#MenuItem
            #label: 'Event Trace'
            #translateLabel: true
            #value: #startStopEventTrace
            #activeHelpKey: #systemEventTrace
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Collect Garbage'
            #translateLabel: true
            #value: #garbageCollect
            #activeHelpKey: #systemGarbageCollect
            #labelImage: #(#ResourceRetriever nil #garbageCollectIcon 'Collect Garbage')
          )
         #(#MenuItem
            #label: 'Collect Garbage And Compress'
            #translateLabel: true
            #value: #compressingGarbageCollect
            #activeHelpKey: #systemGarbageCollectAndCompress
            #labelImage: #(#ResourceRetriever nil #garbageCollectIcon 'Collect Garbage And Compress')
          )
         )
        nil
        nil
      )
!

toolsMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#toolsMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher toolsMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Workspace'
            #nameKey: #workspace
            #value: #openApplication:
            #activeHelpKey: #toolsWorkspace
            #argument: 'Workspace'
            #labelImage: #(#ResourceRetriever nil #startWorkspaceIcon 'Workspace')
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'GUI Painter'
            #nameKey: #guiPainter
            #value: #openApplication:
            #activeHelpKey: #toolsGUIPainter
            #argument: 'UIPainter'
            #labelImage: #(#ResourceRetriever nil #startUIPainterIcon 'GUI Painter')
          )
         #(#MenuItem
            #label: 'Menu Editor'
            #nameKey: #menuEditor
            #value: #openApplication:
            #activeHelpKey: #toolsMenuEditor
            #argument: 'MenuEditor'
            #labelImage: #(#ResourceRetriever nil #startMenuEditorIcon 'Menu Editor')
          )
         #(#MenuItem
            #label: 'Image Editor'
            #nameKey: #imageEditor
            #value: #openApplication:
            #activeHelpKey: #toolsImageEditor
            #argument: 'ImageEditor'
            #labelImage: #(#ResourceRetriever nil #startImageEditorIcon 'Image Editor')
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Changes Browser'
            #translateLabel: true
            #nameKey: #changesBrowser
            #value: #startChangesBrowser
            #activeHelpKey: #toolsChangesBrowser
            #labelImage: #(#ResourceRetriever nil #startChangesBrowserIcon 'Changes Browser')
          )
         #(#MenuItem
            #label: 'SUnit Test'
            #translateLabel: true
            #nameKey: #startSUnitTestRunner
            #value: #startSUnitTestRunner
            #labelImage: #(#ResourceRetriever #NewLauncher #startSUnitIcon 'SUnit Test')
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Misc'
            #translateLabel: true
            #nameKey: #misc
            #activeHelpKey: #toolsMisc
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Projects'
                  #translateLabel: true
                  #activeHelpKey: #toolsMiscProjects
                  #submenu: 
                 #(#Menu
                    #(
                     #(#MenuItem
                        #label: 'New Project'
                        #translateLabel: true
                        #value: #newProject
                        #activeHelpKey: #toolsMiscProjectsNewProject
                      )
                     #(#MenuItem
                        #label: '-'
                      )
                     #(#MenuItem
                        #label: 'Select Project...'
                        #translateLabel: true
                        #value: #selectProject
                        #activeHelpKey: #toolsMiscProjectsSelectProject
                      )
                     )
                    nil
                    nil
                  )
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'New Launcher'
                  #translateLabel: true
                  #value: #startNewLauncher
                  #activeHelpKey: #toolsMiscNewLauncher
                )
               #(#MenuItem
                  #label: 'Old Launcher'
                  #translateLabel: true
                  #value: #startOldLauncher
                  #activeHelpKey: #toolsMiscOldLauncher
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'New Changes Browser'
                  #translateLabel: true
                  #value: #startNewChangesBrowser
                  #activeHelpKey: #toolsMiscNewChangesBrowser
                )
               #(#MenuItem
                  #label: 'Old Changes Browser'
                  #translateLabel: true
                  #value: #startOldChangesBrowser
                  #activeHelpKey: #toolsMiscOldChangesBrowser
                )
               #(#MenuItem
                  #label: '-'
                  #isVisible: #canDoTerminal
                )
               #(#MenuItem
                  #label: 'Terminal'
                  #translateLabel: true
                  #isVisible: #canDoTerminal
                  #value: #openTerminal
                  #activeHelpKey: #toolsTerminal
                )
               #(#MenuItem
                  #label: '-'
                  #isVisible: #canDoTerminal
                )
               #(#MenuItem
                  #label: 'Inspect Global Variables'
                  #translateLabel: true
                  #value: #inspectGlobalVariables
                )
               #(#MenuItem
                  #label: 'Inspect Workspace Variables'
                  #translateLabel: true
                  #value: #inspectWorkspaceVariables
                )
               #(#MenuItem
                  #label: 'Remove All Workspace Variables'
                  #translateLabel: true
                  #value: #removeAllWorkspaceVariables
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
!

windowsMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:NewLauncher andSelector:#windowsMenu
     (Menu new fromLiteralArrayEncoding:(NewLauncher windowsMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Redraw All'
            #translateLabel: true
            #value: #redrawAllWindows
            #activeHelpKey: #windowsRedrawAll
          )
         #(#MenuItem
            #label: 'Iconify All'
            #translateLabel: true
            #value: #iconifyAllWindows
            #activeHelpKey: #windowsIconifyAll
          )
         #(#MenuItem
            #label: 'De-iconify All'
            #translateLabel: true
            #value: #deIconifyAllWindows
            #activeHelpKey: #windowsDeiconifyAll
          )
         #(#MenuItem
            #label: 'Migrate All to...'
            #translateLabel: true
            #value: #migrateAllWindows
            #activeHelpKey: #windowsMigrateAllWindows
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'View Tree'
            #translateLabel: true
            #value: #startWindowTreeView
            #activeHelpKey: #windowsViewTree
          )
         #(#MenuItem
            #label: 'View Tree (all windows)'
            #translateLabel: true
            #value: #openApplication:
            #activeHelpKey: #windowsViewTreeAllViews
            #argument: 'WindowTreeView'
          )
         #(#MenuItem
            #label: 'View Tree (all on all screens)'
            #translateLabel: true
            #value: #startWindowTreeViewForAll
            #activeHelpKey: #windowsViewTreeAllScreens
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Select And Inspect'
            #translateLabel: true
            #value: #viewInspect
            #activeHelpKey: #windowsSelectAndInspect
          )
         #(#MenuItem
            #label: 'Select And Destroy'
            #translateLabel: true
            #value: #viewDestroy
            #activeHelpKey: #windowsSelectAndDestroy
          )
         #(#MenuItem
            #label: 'Select And Migrate to...'
            #translateLabel: true
            #value: #viewMigrate
            #activeHelpKey: #windowsSelectAndMigrate
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Find And Raise...'
            #translateLabel: true
            #value: #findAndRaiseWindow
            #activeHelpKey: #windowsFindAndRaise
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Find And Destroy...'
            #translateLabel: true
            #value: #findAndDestroyWindow
            #activeHelpKey: #windowsFindAndDestroy
            #enabled: #enableDangerousMenuItemsInRemoteLauncher
          )
         #(#MenuItem
            #label: 'Find And Migrate to...'
            #translateLabel: true
            #value: #findAndMigrateWindow
            #activeHelpKey: #windowsFindAndMigrate
          )
         #(#MenuItem
            #label: 'Find And Migrate back...'
            #translateLabel: true
            #value: #findAndMigrateWindowBack
            #activeHelpKey: #windowsFindAndMigrateBack
          )
         #(#MenuItem
            #label: '-'
          )
         #(#MenuItem
            #label: 'Grab Window...'
            #translateLabel: true
            #value: #viewHardcopy
            #activeHelpKey: #windowsGrapWindow
          )
         #(#MenuItem
            #label: 'Grab Widget...'
            #translateLabel: true
            #value: #widgetHardcopy
            #activeHelpKey: #windowsGrapWidget
          )
         #(#MenuItem
            #label: 'Grab Screen...'
            #translateLabel: true
            #value: #fullScreenHardcopy
            #activeHelpKey: #windowsGrapScreen
          )
         #(#MenuItem
            #label: 'Grab Screen Area...'
            #translateLabel: true
            #value: #screenHardcopy
            #activeHelpKey: #windowsGrapScreenArea
          )
         )
        nil
        nil
      )
! !

!NewLauncher class methodsFor:'resources'!

garbageCollectIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#garbageCollectIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher garbageCollectIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'DQD@@@.;.1D[DQDQD@@QDP@@.;.;,[,@@ADP@ADQ@@.;@@.;.1@@@A@@DQD@B;@@@[.;DCH@D@@QDP@K,@@K.;,Q@2@P@ADQ@K.;@@DQDQDPL @@DQDKB;B0@QDQ@@@C@@@QD[B0B0,ADP@"H"@@@ADQ@@@@@@DQ@P@@@0@@DQ@@@@C 8@@ADQL3@@@Q@@@@;.;.@@DCL0H@@@@@@@@NC @@@PLC@ @@@@@@C.;.8@@A@0LB@@@@@@@@8N@@@@DC@0H@@@@@B (@@AD@@PLC@ @@@@****@LG@@A@0LB@@@@@JB CL3L0@DC@0H@@@B***(@0L@Q@SLCL @@@@(J@L3L3AD@L"H @@@@@QDQC@0QDQD@@@DP@@@ADQD@@@@QD@@@@@@@@ @B@ @B@@HB@ H@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@B@@H@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@H@@@H@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 127 127 127 170 170 170 255 0 0 0 255 0 0 0 255 0 255 255 255 255 0 255 0 255 127 0 0 0 127 0 0 0 127 0 127 127 127 127 0 127 0 127]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@G1@@@C>0@@A1=0@@XO^@@FG30@C0@^@AZ@? @)P?8@@@O>@@B#? @C<?8@@TO>@@_#? @B ?8@E@O>@G9S? @)>?8@?JO>@EO3? @APO @@@@@@]7]7\DUUUDAEUUQ@U7]5\EUUUTAUUUU@]U]W\@@a') ; yourself); yourself]
!

saveImageIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#saveImageIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher saveImageIcon'
	ifAbsentPut:[(Depth2Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(2 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'UPSL3L0A@ET7L3L0?PAUML3L3OT@US\3L3C5@ET43L3L?PAUM3L3LO4@USSL3L3=@ET7L3L0?PAUML3L3O4@US\3L3C=@ET43L3L?PAUM@@@@O4@US?????=@ET?UUUU?PAUO7??6?4@US=T?=+=@ET?ZO?Z?PAUO4C?6/4@U]U**)WU@ET@@@@@@@AUUUUUUUUU%Y%UUUTE%%UUUUTU)UEUUUUEUUUUUUVYUUTEUTUUUUDUAUUUUUUQUPUUVUUUUUTU%P@a') ; colorMapFromArray:#[255 255 255 0 0 0 127 127 127 170 170 170]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'C???@@???0@O??<@C???@@???0@O??<@C???@@???0@O??<@C???@@???0@O??<@C???@@???0@O??<@C???@@???0@O??<@C??>@@@@@@@@@@@@;*9R<H*(W)BJ*E:@S.9R,B)HT)@*REJP:$9R<@@a') ; yourself); yourself]
!

startChangesBrowserIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#startChangesBrowserIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startChangesBrowserIcon'
	ifAbsentPut:[(Depth2Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(2 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@B****@@@@@@@@@ @@@B****H@@@@@@@@"@@@C????H @@@@@@@2H@@C????L"@@@@@@@3H@@AUUUUL2@@@@@@@SL@@AUUUUD3@@@_=UUQL@@@EUUUTS@@@A]7UUD@@@@U7]5Q@@@@E7]5T@@@@AUUUU@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@BH@@@@@@@@LB@L@@@@@@@@@@@@@@@@J@@@@@@@@@@@@@@@@@@H@@@@@@@@@@@@@@@a') ; colorMapFromArray:#[0 0 0 255 255 255 127 127 127 170 170 170]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@??8@@O?>@@O?? @C??8@C??>@@??? @???8@O??>@O??? C??? C???8@???8@O??>@C??>@@??? @O?? @C??8@@??8@@O?>@@@@@@@@@@@@@Z.$7LH+-YDBJ+TQ@#.=WHH*+UABJ*5PPZ*$7X@@a') ; yourself); yourself]
!

startFileBrowserIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#startFileBrowserIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startFileBrowserIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@@@@CLA&Y&Y&Y&X@@@@@@@@L0F@@@@@@A @@@@@@@@3@XN;.;.8F@@@@@@@@CLA ;.@@@@@@@@@@@@@L0FC.8O[6=/[0@@@@@@3@X@; [6=/[6@@@@@@CLA DNC6<@@F<@@@@@@L0F@A@F= [0= @@@@@@3@X@@P=/[6=/@@@@@@CLA @@A/[6=/X@@@@@@L0FC0@O[6=/[0@@@@@@3@XF<@@@@@@@@@@@@@CLA = @@@@@@@@@@@@@L0FA/[6=/A @@@@@@@@3@XO[6=/XF@@@@@@@@CLA @@@@@@X@@@@@@@@L0FY&Y&Y&Y @@@@@@@@C@Y&Y&Y&Y&@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@N@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C @b') ; colorMapFromArray:#[0 0 0 255 255 255 255 0 0 0 255 0 0 0 255 0 255 255 255 255 0 255 0 255 127 0 0 0 127 0 0 0 127 0 127 127 127 127 0 127 0 127 127 127 127 170 170 170]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'A??<@@_??@@G??0@A??<@@_??8@G??>@A??? @_??8@G??>@A??? @_??8@G??>@A??? @_??@@G??0@A??<@@_??@@G??0@@??<@@G??@@@@@@@G.P=0AADHP@PQBD@GDP8 AADHD@PQBA@DN^=0@@a') ; yourself); yourself]
!

startImageEditorIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#startImageEditorIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startImageEditorIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@M7]7]7]7]7]7]@@@@@@@@@@@@@@@@@@@@@@@@@"H"H"HDQEUVY @@@@@BH"H3L QDUUY&@@@@@@HA@#L2ADQUU&X@@@@@@"H"H"HH"I&W]0@@@@@BL3L3L "H&Y]7@@@@@@H"H"H"BH"Y%7\@@@@@@#L3L3HDQEUVY @@@@@BH"H"H QDUUY&@@@@@@H3L3L2ADQUU&X@@@@@@"H"H"HH"I&W]0@@@@@BL#L3L "H&Y]7@@@@@@H2L3L2BH"Y%7\@@@@@@"H"H"HBH"H"H @@@@@@@@@@@@@@@@@@@@@@@@H"H"H"H"H"H"H@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C@0@0@0L@L@@@@@@@@@@0@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@L@@@@@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 170 170 170 127 127 127 255 0 0 0 255 0 0 0 255 0 255 255 255 255 0 255 0 255 127 0 0 0 127 0 0 0 127 0 127 127 127 127 0 127 0 127]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'???8@O??>@C??? @???8@O??>PC???&@???90O??>^C???''0???90O??>TC???  ???8HO??>AC??? P???8@O??>@C??? @???8@@@@@@@@@@@@;[7/@D>%J@AJ)P @RK5.@D"%J@AH)R @:JW/@@@a') ; yourself); yourself]
!

startMenuEditorIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self startMenuEditorIcon inspect
     ImageEditor openOnClass:self andSelector:#startMenuEditorIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startMenuEditorIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@DQDQDQDQDQDQD@@@@@@@@@@@@@@@@@@@@@@@@@QH"H DQHQD"H @@@@@ATBH"@RHBH H"@@@@@@H@H"HAT%UUUUT@@@@@@%H"H D%IRT%IP@@@@@BUQIU@UIRT%IR@@@@@@IRHBHAIRT%IRT@@@@@@%H"H ERT%IRT @@@@@BUQIU@RT%IRT%@@@@@@IRHBHAT%IRT%H@@@@@@%H"H D%IRT%IP@@@@@BUQIU@UIRT%IR@@@@@@H"HBHAIRT%IRT@@@@@@"H"H IRT%IRT @@@@@@@@@@@@@@@@@@@@@@@@H"H"H"H"H"H"H@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@APT@@@@@@@@@@@@@@@@@T@@@@@@@@@@@@@@@@@@@@@@@@@T@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@E@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@T@T@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 170 170 170 255 255 0 0 127 127 127 127 127 255 0 0 0 255 0 0 0 255 0 255 255 255 0 255 127 0 0 0 127 0 0 0 127 127 127 0 127 0 0]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'???8@O??>@C??? @???8@O??>PC???&@???90O??>^C???''0???90O??>TC???  ???8HO??>AC??? P???8@O??>@C??? @???8@@@@@@@@@@@@6=D$@O(YI@B*GRP@"9T$@H(WI@BJD2P@"=D<@@@a') ; yourself); yourself]
!

startSUnitIcon
    <resource: #programImage>

    ^ TestRunner defaultIcon
!

startSystemBrowserIcon
    <resource: #programImage>

    ^ SystemBrowser defaultIcon
!

startSystemBrowserOnHistoryClassIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self startSystemBrowserOnHistoryClassIcon inspect
     ImageEditor openOnClass:self andSelector:#startSystemBrowserOnHistoryClassIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startSystemBrowserOnHistoryClassIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@ADQDQDQG0@@@@@@@@@@D"H"H"H.@@@@@@@@@@@RH"H"H"8@@@@@@@@@@O;.;.;.; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@8@@@@@@@@@@@@@@@@@C @@@@@@@@@@@@@@@@@N@@@@@@@@@@@@@@@@@@@@@@@@DQ@@@QG0@@@@@P;.;.@SL@@CL>@@@@@@@@@@@O; @@;.8@@@@@8@@@@@@@@@@@@@@@@@C @@@@@@@@@@@@@@@@@N@@@@@@@@@@@@@@@@@@@@@@@@DQ@@@QG0@@@@@P;.;.@VX@@FY.@@@@@@@@@@@O8@@@C.8@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C @@@@8@8@@N@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@N@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@8@@@8@8@@@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 255 0 0 0 255 0 0 0 255 0 255 255 255 255 0 255 0 255 127 0 0 0 127 0 0 0 127 0 127 127 127 127 0 127 0 127 127 127 127 170 170 170]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'??0^@O?<O0C??FF@??1!! O?<XXC??CF@@ @C@@H@A @B@>7 A0O[8@_?6>@G@=/ @ O[8@H@@@@B@<O A0O[8@_??>@G@;7 @@NY8@@@@@@@@@@@%]7/TITIJUBUBR%P=H$/TIQIJRBTRR$ %\'')P@@a') ; yourself); yourself]
!

startUIPainterIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#startUIPainterIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startUIPainterIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@DQDQDQDQDQDQD@@@@@@@@@@@@@@@@@@@@@@@@@3H"H DQHQD"H @@@@@CLBH"@RHBH H"@@@@@@H@H"HAT%UUUUT@@@@@@%H"H D%IRT%IP@@@@@BUSMU@UIRT%IR@@@@@@IRLBHAIRT%IRT@@@@@@%H"H ERT%IRT @@@@@BUSMU@RT%IRT%@@@@@@IRLBHAT%IRT%H@@@@@@%H"H D%IRT%IP@@@@@BUSMU@UIRT%IR@@@@@@H"LBHAIRT%IRT@@@@@@"H"H IRT%IRT @@@@@@@@@@@@@@@@@@@@@@@@H"H"H"H"H"H"H@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@T@AP@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@T@@@AP@E@@@@@@@@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 170 170 170 255 255 0 0 127 127 127 127 127 255 0 0 0 255 0 0 0 255 0 255 255 255 0 255 127 0 0 0 127 0 0 0 127 127 127 0 127 0 0]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'???8@O??>@C??? @???8@O??>PC???&@???90O??>^C???''8???90O??>TC???  ???8HO??>A#??? X???8@O??>@C??? @???8@@@@@@@@@@@@>QN@@H$Q@@BADP@@.QD@@H$Q@@BIDP@@>_N@@@@a') ; yourself); yourself]
!

startWorkspaceIcon
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     ImageEditor openOnClass:self andSelector:#startWorkspaceIcon
    "

    <resource: #image>

    ^Icon
	constantNamed:#'NewLauncher startWorkspaceIcon'
	ifAbsentPut:[(Depth4Image new) width: 28; height: 28; photometric:(#palette); bitsPerSample:(#(4 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@M7]7]7]7]7]7]7]@@@@@@@@@@@@@@@@@@@@@@@QDQDQDQDQDQDQ@0@@@AUPUUUUAUAQDQDB@@@@EUAUUUTE@@DQDPH@@@@P@E@@UPUPTQDQ@ @@@AAPTEAUAUAQDQDB@@@@D@AP@ETET@DQDPH@@@@QDQDQDQDQEADQ@ @@@ADQDQDQDQDTPQDB@@@@DQDQDQDQDQQDDPH@@@@QDQDQDQDQEDDQ@ @@@ADQDQDQDQDQEADB@@@@DQDQDQDQDQDTDPH@@@@QDQDQDQDQDQDQ@0@@@@@@@@@@@@@@@@@@@@@@L"H"H"H"H"H"H0L@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C@@L@@C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C@@L@@@@@@@@@@b') ; colorMapFromArray:#[0 0 0 255 255 255 170 170 170 127 127 127 255 0 0 0 255 0 0 0 255 0 255 255 255 255 0 255 0 255 127 0 0 0 127 0 0 0 127 0 127 127 127 127 0 127 0 127]; mask:((Depth1Image new) width: 28; height: 28; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'????@O???0C???<@????@O???0C???<@????@O???0C???<@????@O???0C???<@????@O???0C???<@????@O???0C???<@????@@@@@@@@@@@@ //R@HJJT BB"%P@$(/X@IJJU@BR"%H@[O)R@@@a') ; yourself); yourself]
! !

!NewLauncher methodsFor:'accessing'!

menuToolbar
    |menu item|

    menu := Menu new fromLiteralArrayEncoding:(self class menuToolbar).
    menu receiver:self.
    menu findGuiResourcesIn:self.

    ^ menu


! !

!NewLauncher methodsFor:'aspects'!

canDoTerminal
    "return a 'valueHolder', which returns true if the terminal application
     is available. For now, this is true if we run under unix"

    ^ OperatingSystem isUNIXlike 
      or:[OperatingSystem isMSWINDOWSlike]

    "Created: / 27.7.1998 / 12:47:54 / cg"
    "Modified: / 28.4.1999 / 11:55:24 / cg"
!

chickenFunIsRunning
    "return a 'valueHolder', which returns true if the chickenFun demo is running."

    ^ [Demos::ChickenFun notNil
      and:[Demos::ChickenFun isLoaded
      and:[Demos::ChickenFun isRunning]]]
!

chickenFunRunning
    "return a 'valueHolder', which returns true if the chickenFun demo is running."

    ^ [Demos::ChickenFun notNil
      and:[Demos::ChickenFun isLoaded
      and:[Demos::ChickenFun isRunning]]]
!

displaySupportsGLDrawing
    "return a 'valueHolder', which returns true if the GL support
     is available."

    ^ [Screen current supportsGLDrawing]

    "Modified: / 13.2.1998 / 14:26:31 / cg"
    "Created: / 3.5.1999 / 16:47:22 / cg"
!

enableDangerousMenuItemsInRemoteLauncher

    |holder|

    (holder := builder bindingAt:#enableDangerousMenuItemsInRemoteLauncher) isNil ifTrue:[
        builder aspectAt:#enableDangerousMenuItemsInRemoteLauncher put:(holder :=  true asValue).
    ].
    ^ holder
!

isMainLauncherHolder
    ^ [ isMainLauncher ]
!

isNotMainLauncherHolder
    ^ [ isMainLauncher not ]
!

javaSupportPresent
    "return a 'valueHolder', which returns true if the java support
     is available."

    ^ [JavaVM notNil and:[JavaVM isBehavior and:[JavaVM isLoaded]]]

    "Created: / 13.2.1998 / 14:25:59 / cg"
    "Modified: / 13.2.1998 / 14:26:31 / cg"
!

libraryBuilderAvailable
    ^ false

    "Created: / 20.6.1998 / 16:54:31 / cg"
!

packageDialogVisible
    ^ false
!

showActiveHelpMenuItem
    ^ false
! !

!NewLauncher methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "care for project changes & update my infoView"

    ((something == #currentProject) or:[changedObject == Project]) ifTrue: [self updateInfo]

!

updateInfo
    "update the infoView from the current project"

    |project projectName projectDir packageName defNameSpace msg args projectInfo|

    (Project isNil or:[(project := Project current) isNil]) ifTrue:[
        projectName := '* none *'.
        projectDir := '.'.
        packageName := '* none *'.
    ] ifFalse:[
        projectName := project name.
        projectDir := project directory.
        packageName := project package.
        defNameSpace := project defaultNameSpace.
    ].
    defNameSpace isNil ifTrue:[
        defNameSpace := Smalltalk.
    ].

    msg := 'Project: ''%1'' fileOut to: ''%3'' package: ''%2'''.
    defNameSpace == Smalltalk ifTrue:[
        args := Array 
                    with:projectName
                    with:packageName 
                    with:(projectDir contractTo:30).
    ] ifFalse:[
        msg := msg , '  nameSpace: %4'.
        args := Array 
                        with:projectName
                        with:packageName 
                        with:(projectDir contractTo:30)
                        with:defNameSpace name.
    ].

    self valueOfInfoLabel value:(projectInfo := resources string:msg withArgs:args).
    ^projectInfo
! !

!NewLauncher methodsFor:'help'!

defaultInfoLabel

    ^self updateInfo

! !

!NewLauncher methodsFor:'menu configuration'!

addMenuItem:newItem in:where position:positionSpecOrNilArg space:space
    "adds a menu item;
       where == #menu        - menu item is added at the end of the sub menu 'Tools',
       where == #toolbar     - menu item is added at the end of the tool bar,
       where == #menu.<name> - menu item is added at the end of the sub menu named 'name',

    position may be one of:
        ( #before <someItemPath> )
        ( #after  <someItemPath> )
        ( #first )   or #first
        ( #last )    or #last
        nil   (same as last)

     If space is true, some empty space is inserted.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar or menu.
    "

    |what menuPanel freeMenuIndex mainMenuPanel item subViews subMenuPath 
     rest subMenu subItem nItems idx 
     positionSpecOrNil itemNameOrNil before|

    positionSpecOrNil := positionSpecOrNilArg.
    positionSpecOrNil isArray ifTrue:[
        positionSpecOrNil size > 1 ifTrue:[
            itemNameOrNil := positionSpecOrNil at:2.
        ].
        positionSpecOrNil := positionSpecOrNil at:1.
    ].
    before := (positionSpecOrNil == #first) or:[positionSpecOrNil == #before].

    what := where.
    (what isNil or: [what = 'toolbar']) ifTrue:[
        "/ look if not already in the toolBar
        menuPanel := builder namedComponents at: #menuToolbarView ifAbsent:nil.
        menuPanel isNil ifTrue:[
            'NewLauncher [warning]: addUserTool failed - no menuPanel' infoPrintCR.
        ] ifFalse:[
            idx := 0.
            newItem nameKey notNil ifTrue:[
                idx := menuPanel findFirst: [:i| i nameKey = newItem nameKey].
            ].
            idx == 0 ifTrue:[
                idx := menuPanel findFirst: [:i| (newItem activeHelpKey notNil and:[ i activeHelpKey = newItem activeHelpKey])
                                                  or:[ newItem label notNil and:[ i label = newItem label] ]]
            ].
            idx == 0 ifTrue:[
                "/ ok, not there; search for the position to put the item
                nItems := menuPanel numberOfItems.
                freeMenuIndex := 0.
                itemNameOrNil notNil ifTrue:[
                    freeMenuIndex := menuPanel findFirst: [:i| i nameKey = itemNameOrNil].
                    freeMenuIndex == 0 ifTrue:[
                        freeMenuIndex := menuPanel findFirst: [:i| i activeHelpKey = itemNameOrNil or:[i label = itemNameOrNil]].
                    ]
                ].

                freeMenuIndex == 0 ifTrue:[
                    freeMenuIndex := before ifTrue:1 ifFalse:[nItems + 1].
                ] ifFalse:[
                    before ifFalse:[freeMenuIndex := freeMenuIndex +1].
                ].

                space ifTrue:[
                    (menuPanel createAtIndex: freeMenuIndex) menuItem: (MenuItem labeled: '').
                    freeMenuIndex := freeMenuIndex + (before ifTrue:0 ifFalse:1).

                ].

                (menuPanel createAtIndex: freeMenuIndex) menuItem:newItem.

                UserAddedToolBarItems isNil ifTrue: [UserAddedToolBarItems := Dictionary new].
                UserAddedToolBarItems at:newItem put:(AddedToolInfo new
                                                    item:newItem;
                                                    where:where;
                                                    positionSpec:positionSpecOrNilArg;
                                                    space:space;
                                                    before:before;
                                                    menuWithNewItem:menuPanel;
                                                    yourself)
            ].
        ].
    ].

    subMenuPath := #( 'tools' ).
    (what notNil and:[what includes:$.]) ifTrue:[
        subMenuPath := (what asCollectionOfSubstringsSeparatedBy:$.) copyFrom:2.
        what := #menu.
    ].

    (what isNil or: [what = 'menu']) ifTrue:[
        mainMenuPanel := self builder menuBar.
        mainMenuPanel isNil ifTrue:[
            subViews := self builder window subViews.
            subViews notNil ifTrue:[
                mainMenuPanel := subViews at:1 ifAbsent:nil.
            ]
        ].
        mainMenuPanel isNil ifTrue:[
            'NewLauncher [warning]: addUserTool failed - no mainMenu' infoPrintCR.
            ^ self
        ].

        item := mainMenuPanel itemAt:(subMenuPath first).
        item isNil ifTrue:[
            item := mainMenuPanel itemAt:'tools'.
"/            item isNil ifTrue:[
"/                item := mainMenuPanel itemAt:4
"/            ].
        ].
        item isNil ifTrue:[
            'NewLauncher [warning]: addUserTool failed - no tools menu' infoPrintCR.
            ^ self
        ].

        rest := subMenuPath copyFrom:2.
        [rest size >= 1] whileTrue:[
            subMenu := item submenu.
            subMenu isNil ifTrue:[
                rest := nil
            ] ifFalse:[
                subItem := subMenu itemAt:(rest first).
                subItem isNil ifTrue:[
                    rest := nil
                ] ifFalse:[
                    item := subItem.
                    rest := rest copyFrom:2.
                ]
            ]
        ].

        item isNil ifTrue:[^ self].
        menuPanel := item submenu.

        "/ look if not already in the menu
        idx := 0.
        newItem nameKey notNil ifTrue:[
            idx := menuPanel findFirst: [:i| i nameKey = newItem nameKey].
        ].
        idx == 0 ifTrue:[
            idx := menuPanel findFirst: [:i| (newItem activeHelpKey notNil and:[ i activeHelpKey = newItem activeHelpKey])
                                              or:[ newItem label notNil and:[ i label = newItem label] ]]
        ].

        idx == 0 ifTrue:[
            "/ ok, not there; search for the position to put the item

            nItems := menuPanel numberOfItems.
            freeMenuIndex := 0.
            itemNameOrNil notNil ifTrue:[
                freeMenuIndex := menuPanel findFirst: [:i| i nameKey = itemNameOrNil].
                freeMenuIndex == 0 ifTrue:[
                    freeMenuIndex := menuPanel findFirst: [:i| i activeHelpKey = itemNameOrNil or:[i label = itemNameOrNil]].
                ]
            ].
            freeMenuIndex == 0 ifTrue:[
                freeMenuIndex := before ifTrue:1 ifFalse:[nItems + 1].
            ] ifFalse:[
                before ifFalse:[freeMenuIndex := freeMenuIndex +1].
            ].
            space ifTrue:[
                (menuPanel createAtIndex: freeMenuIndex) menuItem: (MenuItem labeled: '-').
                freeMenuIndex := freeMenuIndex + (before ifTrue:0 ifFalse:1).
            ].

            (menuPanel createAtIndex:freeMenuIndex) menuItem:newItem.

            UserAddedMenuItems isNil ifTrue: [UserAddedMenuItems := Dictionary new].
            UserAddedMenuItems at:newItem put:(AddedToolInfo new
                                                item:newItem;
                                                where:where;
                                                positionSpec:positionSpecOrNilArg;
                                                space:space;
                                                before:before;
                                                menuWithNewItem:menuPanel;
                                                yourself)
        ].
    ].

    "
     UserAddedToolBarItems := nil.
     UserAddedMenuItems := nil.
     NewLauncher open.

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo';
                        value: [Transcript showCR:'foo'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #foo)
        in:#menu
        position:#(#before 'Workspace')
        space:true

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Bar';
                        value: [Transcript showCR:'bar'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #bar)
        in:#menu
        position:#(#after #foo)
        space:true

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Baz';
                        value: [Transcript showCR:'baz'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #baz)
        in:#menu
        position:#(#before #bar)
        space:false

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Baz2';
                        value: [Transcript showCR:'baz2'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #baz2)
        in:#menu
        position:#(#after #bar)
        space:false

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo2';
                        value: [Transcript showCR:'foo2'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #foo2)
        in:'menu.classes'
        position:#last
        space:false

     Transcript topView application
        addMenuItem:(MenuItem new 
                        label: 'Foo3';
                        value: [Transcript showCR:'foo3'];
                        isButton: false;
                        labelImage: nil;
                        nameKey: #foo3)
        in:'menu.classes.special'
        position:#first
        space:true
    "
!

addUserTool:toolName action:actionBlock icon:iconOrNil
    "adds a menu item labeled toolName, and action and icon both to the
     sub menu 'Tools' and the tool bar.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar.
     OBSOLETE
    "

    self 
        addUserTool:toolName 
        action:actionBlock 
        in:nil 
        icon:iconOrNil 
        space:true

    "
     Transcript topView application
        addUserTool:'Foo' 
        action:[Transcript showCR:'foo'] 
        icon:nil
    "
!

addUserTool:toolName action:actionBlock in:where after:afterOrNil icon:icon space:space
    "adds a menu item labeled toolName, and actionBlock and icon;
       where == #menu        - menu item is added at the end of the sub menu 'Tools',
       where == #toolbar     - menu item is added at the end of the tool bar,
       where == #menu.<name> - menu item is added at the end of the sub menu named 'name',

     If space is true, some empty space is inserted.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar or menu.
     OBSOLETE
    "

    ^ self
        addUserTool:toolName action:actionBlock in:where position:afterOrNil before:false icon:icon space:space

    "
     Transcript topView application
        addUserTool:'Foo' 
        action:[Transcript showCR:'foo']
        in:#menu
        icon:nil
        space:false
    "
    "
     Transcript topView application
        addUserTool:'Bar' 
        action:[Transcript showCR:'bar']
        in:#menu
        icon:nil
        space:false
    "
!

addUserTool:toolName action:actionBlock in:where before:afterOrNil icon:icon space:space
    "adds a menu item labeled toolName, and actionBlock and icon;
       where == #menu        - menu item is added at the end of the sub menu 'Tools',
       where == #toolbar     - menu item is added at the end of the tool bar,
       where == #menu.<name> - menu item is added at the end of the sub menu named 'name',

     If space is true, some empty space is inserted.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar or menu.
     OBSOLETE
    "

    ^ self
        addUserTool:toolName action:actionBlock in:where position:afterOrNil before:true icon:icon space:space
!

addUserTool:toolName action:actionBlock in:what icon:icon space:space
    "adds a menu item labeled toolName, and actionBlock and icon;
     for what == #menu    menu item is added at the end of the sub menu 'Tools',
     for what == #toolbar menu item is added at the end of the tool bar,
     If space is true, some empty space is inserted.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar or menu.
     OBSOLETE
    "

    ^ self
        addUserTool:toolName 
        action:actionBlock 
        in:what 
        after:nil 
        icon:icon 
        space:space

    "
     UserAddedTools := nil.
     NewLauncher open.

     Transcript topView application
        addUserTool:'Foo' 
        action:[Transcript showCR:'foo']
        in:#menu
        icon:nil
        space:false
    "
    "
     Transcript topView application
        addUserTool:'Bar' 
        action:[Transcript showCR:'bar']
        in:#menu
        icon:nil
        space:true
    "

!

addUserTool:toolName action:actionBlock in:where position:itemNameOrNil before:before icon:icon space:space
    "adds a menu item labeled toolName, and actionBlock and icon;
       where == #menu        - menu item is added at the end of the sub menu 'Tools',
       where == #toolbar     - menu item is added at the end of the tool bar,
       where == #menu.<name> - menu item is added at the end of the sub menu named 'name',

     If space is true, some empty space is inserted.
     This can be invoked by a classes #initialize method, to add an item
     for itself to the toolbar or menu.
     OBSOLETE
    "

    |newItem positionSpecOrNilArg|

    newItem := (MenuItem new 
                    label: toolName;
                    value: actionBlock;
                    isButton: false;
                    labelImage: icon;
                    nameKey: toolName asSymbol;
                    activeHelpKey: toolName asSymbol).

    itemNameOrNil isNil ifTrue:[
        positionSpecOrNilArg := before ifTrue:[#first] ifFalse:[#last].
    ] ifFalse:[
        positionSpecOrNilArg := before ifTrue:[#before] ifFalse:[#after].
        positionSpecOrNilArg := Array with:itemNameOrNil with:positionSpecOrNilArg.
    ].

    ^ self addMenuItem:newItem in:where position:positionSpecOrNilArg space:space

!

removeUserTool:toolNameOrMenuItem
    "removes a menu item labeled toolName
     This can be invoked by a classes #deinitialize method, 
     to remove its item from the toolbar or menu.
    "
    self class removeUserTool:toolNameOrMenuItem
!

removeUserTool:toolNameOrMenuItem from:addedToolsCollection
    "removes a menu item labeled toolName
     This can be invoked by a classes #deinitialize method, 
     to remove its item from the toolbar or menu.
    "

    self class removeUserTool:toolNameOrMenuItem from:addedToolsCollection

    "
     Transcript topView application
        removeUserTool:'Bar' 
    "
    "
     Transcript topView application
        removeUserTool:'Foo' 
    "

!

userAddedMenuItems
    "return a dictionary of user-added menu item infos.
    "

    ^ UserAddedMenuItems ? #()


!

userAddedToolBarItems
    "return a dictionary of user-added toolBar item infos.
    "

    ^ UserAddedToolBarItems ? #()


! !

!NewLauncher methodsFor:'private'!

menuClassHistory
    "returns a sub menu on the history of the classes"

    |menu history|

    BrowserView checkClassHistory.

    history := BrowserView classHistory.

    menu := Menu new receiver: self.
    menu addItemGroup: (history collect:
	[:histEntry|

	    MenuItem new 
		label: (histEntry upTo: $ ); 
		value: [SystemBrowser open loadFromMessage: histEntry]; 
		activeHelpKey: #classesSystemBrowserOnClass
	]
    ).
    menu addItem: (MenuItem new 
			label: 'Empty History'; 
			value: [BrowserView classHistory removeAll]; 
			translateLabel: true;
			enabled:(history notEmpty);
			activeHelpKey: #historyEmptyMenu).

    menu findGuiResourcesIn:self.
    ^menu

    "Modified: / 8.7.1998 / 00:59:50 / cg"
! !

!NewLauncher methodsFor:'private - settings callBacks'!

reopenLauncher
    "reopen a new launcher.
     for now (since style & language settings currently do
     not affect living views ...)
     WARNING: bad design: Message known in LauncherDialogs"

    |newLauncher wasShowingHelp|

    wasShowingHelp := self showingHelp.
    newLauncher := super reopenLauncher.
    newLauncher showingHelp:wasShowingHelp.
    ^ newLauncher
! !

!NewLauncher methodsFor:'queries'!

preferredExtent

    ^super preferredExtent max: Screen current extent//(2.5@3.5)


! !

!NewLauncher methodsFor:'startup / release'!

allButOpenInterface:anInterface
    "sent by my superclass to open up my interface"

    "/ if there is already a transcript on my device,
    "/ I am a slave launcher with limited functionality.

    Transcript notNil ifTrue:[
        Transcript ~~ Stderr ifTrue:[
            isMainLauncher := (Transcript graphicsDevice == device).
            self enableDangerousMenuItemsInRemoteLauncher value: isMainLauncher.
        ] ifFalse:[
            isMainLauncher := true
        ]
    ] ifFalse:[
        isMainLauncher := true
    ].

    super allButOpenInterface:anInterface.

    self setupTranscript; updateInfo.
    Project notNil ifTrue: [Project addDependent:self].
    self class openLaunchers add: self.
    ^ builder

    "Created: / 5.2.1998 / 19:45:07 / cg"
    "Modified: / 20.6.1998 / 14:53:58 / cg"
!

postBuildWith:aBuilder
    "setup my preferred size"

    super postBuildWith:aBuilder.
    aBuilder window extent:(self preferredExtent).
!

postOpenWith:aBuilder
    |toolInfo|

    "/ increase my priority"
"/    self windowGroup process priority:(Processor userSchedulingPriority + 1).
    Processor activeProcess priority:(Processor userSchedulingPriority + 1).

    "/ add user tools
    UserAddedToolBarItems notNil ifTrue:[
        toolInfo := UserAddedToolBarItems.
        UserAddedToolBarItems := nil.
        toolInfo do:[:toolInfo| 
            self 
                addMenuItem:toolInfo item 
                in:toolInfo where
                position:toolInfo positionSpec
                space:toolInfo space
        ].
    ].
    UserAddedMenuItems notNil ifTrue:[
        toolInfo := UserAddedMenuItems.
        UserAddedMenuItems := nil.
        toolInfo do:[:toolInfo| 
            self 
                addMenuItem:toolInfo item 
                in:toolInfo where
                position:toolInfo positionSpec
                space:toolInfo space
        ].
    ].

    super postOpenWith:aBuilder.

    "/ set the time-block
    UserPreferences current showClockInLauncher ifTrue:[
        self startClock
    ].

    "/ change my minimum height ...
    self window minExtent:(self window minExtent x
                           @
                           (self window minExtent y
                            "/ + (builder componentAt:'infoBarSubSpec') height
                            - 12
                           )
                          ).
!

reOpen
    "reopen a new launcher.
     for now (since style & language settings currently do
     not affect living views ...)"

    self reopenLauncher "/ WARNING: bad design: Message known in LauncherDialogs

    "Modified: / 31.7.1998 / 22:48:12 / cg"
!

requestForWindowClose
    |answer|

    isMainLauncher ifFalse:[
        "/ remote launchers may not finish ST/X

        answer := Dialog 
                    confirmWithCancel:(resources string:'Really close %1 (slave)?' with:self class name)
                    labels:(resources array:#('Cancel' 'Close'))
                    default:1.
        answer isNil ifTrue:[
            "/ cancel
            ^ false
        ].
        ^ true
    ].

    ^ super requestForWindowClose
!

restarted
    "image restart - since WindowGroup recreates the process with
     the default priority, we have to raise the prio again.
     Mhmh - this looks like a bug to me ...
     Also, the cursor (which was stored as a write or waitCursor) must
     be reset to normal."

    Processor activeProcess priority:(Processor userSchedulingPriority + 1).
"/    builder window extent: self preferredExtent.
    super restarted

!

setupTranscript 
    "create the transcript view"

    |launcher oldLauncherClass|

    "/ check if this is an additional launcher on a remote display.
    "/ if so, do not close the real launcher.

    (Transcript notNil and:[Transcript ~~ Stderr]) ifTrue:[
        isMainLauncher ifTrue:[
            launcher := Transcript topView application
        ] ifFalse:[
            launcher := self class current.
        ].

        (launcher notNil and:[launcher ~~ self]) ifTrue:[
            launcher window graphicsDevice == device ifTrue:[
                OpenLaunchers notNil ifTrue:[
                    OpenLaunchers remove:launcher ifAbsent:nil.
                ].
                ((oldLauncherClass := Smalltalk at:#Launcher) notNil 
                and:[oldLauncherClass isLoaded]) ifTrue: [
                    oldLauncherClass openLaunchers remove:launcher ifAbsent:nil
                ].
                launcher close
            ]
        ]
    ].

    transcript := (builder componentAt: #transcriptView) subViews first.

    isMainLauncher ifTrue:[
        transcript beTranscript.
    ] ifFalse:[
        transcript showCR:'**************** Notice ***********************'.
        transcript showCR:'**       this is NOT the Transcript          **'.
        transcript showCR:'** The real Transcript is on the main screen **'.
        transcript showCR:'**                                           **'.
        transcript showCR:'** Menus affecting common state are disabled **'.
        transcript showCR:'***********************************************'.
    ]

    "Modified: / 5.3.1999 / 18:00:36 / cg"
!

uninitialize

    super uninitialize.

    OpenLaunchers notNil ifTrue:[OpenLaunchers remove:self ifAbsent:nil].
    Project notNil ifTrue:[Project removeDependent:self]
! !

!NewLauncher methodsFor:'user actions - demos'!

openDemo:className
    "open a demo, given its name.
     Looks in both the Smalltalk- and the Demos-Namespace
     for that class."

    self openApplication:className nameSpace:Demos

!

openMandelbrotDemo
    self openDemo:#ComplexIterationView 

    "Created: / 8.7.1998 / 20:36:37 / cg"
!

startPingPong2
    "opens a 2-user PingPong game"

    self openApplication:'PingPongGame' nameSpace:Games with:#open2PlayerGame

    "Modified: / 13.12.1999 / 22:24:15 / cg"
!

startReversi
    "opens a reversi game (java)"

    self openApplication:'JavaAppletDemo3' nameSpace:CodingExamples_GUI

    "Modified: / 13.12.1999 / 22:24:15 / cg"
!

startStopDemo:className
    "start/stop a demo, given its name.
     Looks in both the Smalltalk- and the Demos-Namespace
     for that class."

    |cls|

    cls := self findApplicationClass:className nameSpace:Demos.
    cls isNil ifTrue:[
        ^ self
    ].

    Autoload autoloadFailedSignal handle:[:ex |
        self warn:(resources string:'Sorry, the %1 class seems to be not available.' with:cls name)
    ] do:[
        self withWaitCursorDo:[
            cls isRunning ifTrue:[
                cls stop
            ] ifFalse:[
                cls start
            ]
        ]
    ]
!

startTicTacToe2
    "opens a 2-user ticTacToe game"

    self openApplication:'TicTacToeGame' nameSpace:Games with:#open2UserGame
! !

!NewLauncher methodsFor:'user actions - file'!

exit
    "saves a snapshot image and exits, after asking for a fileName"

    |fileName saveAndExit box|

    box := EnterBox2 title:(resources string:'Save image before exiting?')
        okText:(resources string:'Save & Exit') 
        abortText:(resources string:'Cancel')
        action:[:str | fileName := str. saveAndExit := true].
    box label: (resources string:'Exiting ST/X').
    box initialText: ObjectMemory nameForSnapshot.
    box okText2:(resources string:'Exit') action2:[:str|saveAndExit := false].
    box showAtPointer.

    saveAndExit notNil ifTrue:[
        saveAndExit ifTrue:[
            self saveImageAs: fileName
        ].
        Smalltalk exit
    ]

    "Modified: / 23.4.1998 / 18:37:46 / cg"
!

saveImage
    "save image"

    self withCursor:Cursor write do:[
        (ObjectMemory snapShotOn:ObjectMemory nameForSnapshot) ifFalse:[
            self warn:(resources string:'Failed to save snapshot image (disk full or not writable)').
        ]
    ].

!

saveImageAs
    "save image, after asking for a file name"

    self saveImageAs: (
	FileSelectionBrowser 
	    request: (resources string:'Save Image As') 
	    fileName: ObjectMemory nameForSnapshot
	    inDirectory: Filename currentDirectory name
	    withFileFilters: #('*.img'))

    "Modified: / 23.4.1998 / 18:25:17 / cg"
! !

!NewLauncher methodsFor:'user actions - help'!

activeHelp

    helpIsOn isNil ifTrue:[
        helpIsOn := false asValue
    ].
    ^ helpIsOn

!

toggleActiveHelp:aBoolean
    "turn on/off active help"

    ActiveHelp notNil ifTrue:[
	self activeHelp value:aBoolean.
	aBoolean ifTrue:[
	    ActiveHelp start
	] ifFalse:[
	    ActiveHelp stop
	]
    ].

    "Modified: / 18.8.1998 / 16:06:27 / cg"
! !

!NewLauncher methodsFor:'user actions - system'!

initJavaVM
    JavaVM initializeVM

    "Created: / 9.2.1998 / 12:06:07 / cg"
!

startLatencyMonitor
    "open an interruptLatencyMonitor view"

    InterruptLatencyMonitor notNil ifTrue:[
        Autoload autoloadFailedSignal catch:[
            InterruptLatencyMonitor autoload.
        ].
        InterruptLatencyMonitor isLoaded ifTrue:[
            InterruptLatencyMonitor open.
            ^ self.
        ]
    ].
    self warn:'Sorry - the irq latency monitor is not available
in this release'.

! !

!NewLauncher methodsFor:'user actions - windows'!

redrawAllWindows
    device redrawAllWindows.
!

widgetHardcopy
    "after a second (to allow redraw of views under menu ...),
     let user specify a widget and save its contents."

    Processor 
	addTimedBlock:[
			|v|
			(v := Screen current viewFromUser) notNil ifTrue:[
			    self saveScreenImage:(Image fromView:v) defaultName:'hardcopy'
			]
		      ] 
	afterSeconds:1

    "Created: / 21.8.1998 / 20:44:12 / cg"
! !

!NewLauncher::AddedToolInfo methodsFor:'accessing'!

before
    "return the value of the instance variable 'before' (automatically generated)"

    ^ before
!

before:something
    "set the value of the instance variable 'before' (automatically generated)"

    before := something.
!

item
    "return the value of the instance variable 'item' (automatically generated)"

    ^ item
!

item:something
    "set the value of the instance variable 'item' (automatically generated)"

    item := something.
!

menuWithNewItem
    "return the value of the instance variable 'menuWithNewItem' (automatically generated)"

    ^ menuWithNewItem
!

menuWithNewItem:something
    "set the value of the instance variable 'menuWithNewItem' (automatically generated)"

    menuWithNewItem := something.
!

positionSpec
    "return the value of the instance variable 'positionSpec' (automatically generated)"

    ^ positionSpec
!

positionSpec:something
    "set the value of the instance variable 'positionSpec' (automatically generated)"

    positionSpec := something.
!

space
    "return the value of the instance variable 'space' (automatically generated)"

    ^ space
!

space:something
    "set the value of the instance variable 'space' (automatically generated)"

    space := something.
!

where
    "return the value of the instance variable 'where' (automatically generated)"

    ^ where
!

where:something
    "set the value of the instance variable 'where' (automatically generated)"

    where := something.
! !

!NewLauncher class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libtool/NewLauncher.st,v 1.209 2000-12-07 07:51:48 cg Exp $'
! !
